Index: buildall.sh
===================================================================
--- buildall.sh	(revision 310)
+++ buildall.sh	(revision 311)
@@ -1,5 +1,6 @@
-export PATH=${PATH}:/home/markw/fpga/altera/13.0sp1/quartus/bin
-#export PATH=${PATH}:/home/markw/fpga/altera/14.0/quartus/bin
+export ORIGPATH=${PATH}
+
+export PATH=${ORIGPATH}:/home/markw/fpga/altera/13.0sp1/quartus/bin
 cd de1
 ./build.sh ALL > build.log 2> build.err&
 cd ../chameleon
@@ -21,6 +22,11 @@
 cd ../mcctv_5200
 ./build.sh ALL &
 
-# TODO variations?
-# TODO SOCkit
 
+export PATH=${ORIGPATH}:/home/markw/fpga/altera/14.0/quartus/bin:/home/markw/fpga/altera/14.0/quartus/sopc_builder/bin/
+cd sockit
+./build.sh
+
+export PATH=${ORIGPATH}
+unset ORIGPATH
+
Index: package.pl
===================================================================
--- package.pl	(revision 310)
+++ package.pl	(revision 311)
@@ -52,6 +52,14 @@
 push @files, glob("de1_5200/build*/output_files/*.summary");
 push @files, glob("de1_5200/build*/output_files/*.rpt");
 
+push @files, glob("sockit/build*/output_files/*.sof");
+push @files, glob("sockit/build*/output_files/*.pof");
+push @files, glob("sockit/build*/output_files/*.summary");
+push @files, glob("sockit/build*/output_files/*.rpt");
+push @files, glob("sockit/SOCKIT.elf");
+push @files, glob("sockit/type");
+push @files, glob("sockit/reboot");
+
 push @files, glob("replay/sdcard/*.bin");
 push @files, glob("replay/sdcard/*.ini");
 
Index: sockit/atari800core_sockit.vhdl
===================================================================
--- sockit/atari800core_sockit.vhdl	(revision 310)
+++ sockit/atari800core_sockit.vhdl	(revision 311)
@@ -61,7 +61,7 @@
 	AUD_XCK : out std_logic;
 
 	--//////////// I2C for Audio  //////////
-	AUD_I2C_SCLK : out std_logic;
+	AUD_I2C_SCLK : inout std_logic;
 	AUD_I2C_SDAT : inout std_logic;
 
 	--//////////// SDRAM //////////
@@ -84,7 +84,56 @@
 
 	--//////////// HSMC : in std_logic; HSMC connect to HTG - HSMC to PIO Adaptor //////////
 	GPIO0 : inout std_logic_vector(35 downto 0);
-	GPIO1 : inout std_logic_vector(35 downto 0)
+	GPIO1 : inout std_logic_vector(35 downto 0);
+	
+	-- HPS PINs (these are not set when flashing fpga, but by preloader...
+	HPS_DDR3_A:OUT STD_LOGIC_VECTOR(14 downto 0);
+	HPS_DDR3_BA: OUT STD_LOGIC_VECTOR(2 downto 0);
+	HPS_DDR3_CAS_N: OUT STD_LOGIC;
+	HPS_DDR3_CKE:OUT STD_LOGIC;
+	HPS_DDR3_CK_N: OUT STD_LOGIC;
+	HPS_DDR3_CK_P: OUT STD_LOGIC;
+	HPS_DDR3_CS_N: OUT STD_LOGIC;
+	HPS_DDR3_DM: OUT STD_LOGIC_VECTOR(3 downto 0);
+	HPS_DDR3_DQ: INOUT STD_LOGIC_VECTOR(31 downto 0);
+	HPS_DDR3_DQS_N: INOUT STD_LOGIC_VECTOR(3 downto 0);
+	HPS_DDR3_DQS_P: INOUT STD_LOGIC_VECTOR(3 downto 0);
+	HPS_DDR3_ODT: OUT STD_LOGIC;
+	HPS_DDR3_RAS_N: OUT STD_LOGIC;
+	HPS_DDR3_RESET_N: OUT STD_LOGIC;
+	HPS_DDR3_RZQ: IN STD_LOGIC;
+	HPS_DDR3_WE_N: OUT STD_LOGIC;
+	HPS_ENET_GTX_CLK: OUT STD_LOGIC;
+	HPS_ENET_MDC:OUT STD_LOGIC;
+	HPS_ENET_MDIO:INOUT STD_LOGIC;
+	HPS_ENET_RX_CLK: IN STD_LOGIC;
+	HPS_ENET_RX_DATA: IN STD_LOGIC_VECTOR(3 downto 0);
+	HPS_ENET_RX_DV: IN STD_LOGIC;
+	HPS_ENET_TX_DATA: OUT STD_LOGIC_VECTOR(3 downto 0);
+	HPS_ENET_TX_EN: OUT STD_LOGIC;
+	HPS_SD_CLK: OUT STD_LOGIC;
+	HPS_SD_CMD: INOUT STD_LOGIC;
+	HPS_SD_DATA: INOUT STD_LOGIC_VECTOR(3 downto 0);
+	HPS_UART_RX: IN STD_LOGIC;
+	HPS_UART_TX: OUT STD_LOGIC;
+	HPS_USB_CLKOUT: IN STD_LOGIC;
+	HPS_USB_DATA:INOUT STD_LOGIC_VECTOR(7 downto 0);
+	HPS_USB_DIR: IN STD_LOGIC;
+	HPS_USB_NXT: IN STD_LOGIC;
+	HPS_USB_STP: OUT STD_LOGIC;
+	HPS_FLASH_DATA : INOUT STD_LOGIC_VECTOR(3 downto 0);
+	HPS_FLASH_DCLK : OUT STD_LOGIC;
+	HPS_FLASH_NCSO : OUT STD_LOGIC;
+	HPS_I2C_CLK : INOUT STD_LOGIC;
+	HPS_I2C_SDA : INOUT STD_LOGIC;
+	HPS_LCM_SPIM_CLK : OUT STD_LOGIC;
+	HPS_LCM_SPIM_MISO : IN STD_LOGIC;
+	HPS_LCM_SPIM_MOSI : OUT STD_LOGIC;
+	HPS_LCM_SPIM_SS : OUT STD_LOGIC;	
+	HPS_SPIM_CLK : OUT STD_LOGIC;
+	HPS_SPIM_MISO : IN STD_LOGIC;
+	HPS_SPIM_MOSI : OUT STD_LOGIC;
+	HPS_SPIM_SS : OUT STD_LOGIC
 	);
 END atari800core_sockit;
 
@@ -96,8 +145,116 @@
 		return v;
 	end;
 
+    component atari_hps is
+        port (
+            clk_clk                               : in    std_logic                     := 'X';             -- clk
+            hps_0_h2f_reset_reset_n               : out   std_logic;                                        -- reset_n
+            hps_0_hps_io_hps_io_emac1_inst_TX_CLK : out   std_logic;                                        -- hps_io_emac1_inst_TX_CLK
+            hps_0_hps_io_hps_io_emac1_inst_TXD0   : out   std_logic;                                        -- hps_io_emac1_inst_TXD0
+            hps_0_hps_io_hps_io_emac1_inst_TXD1   : out   std_logic;                                        -- hps_io_emac1_inst_TXD1
+            hps_0_hps_io_hps_io_emac1_inst_TXD2   : out   std_logic;                                        -- hps_io_emac1_inst_TXD2
+            hps_0_hps_io_hps_io_emac1_inst_TXD3   : out   std_logic;                                        -- hps_io_emac1_inst_TXD3
+            hps_0_hps_io_hps_io_emac1_inst_RXD0   : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RXD0
+            hps_0_hps_io_hps_io_emac1_inst_MDIO   : inout std_logic                     := 'X';             -- hps_io_emac1_inst_MDIO
+            hps_0_hps_io_hps_io_emac1_inst_MDC    : out   std_logic;                                        -- hps_io_emac1_inst_MDC
+            hps_0_hps_io_hps_io_emac1_inst_RX_CTL : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RX_CTL
+            hps_0_hps_io_hps_io_emac1_inst_TX_CTL : out   std_logic;                                        -- hps_io_emac1_inst_TX_CTL
+            hps_0_hps_io_hps_io_emac1_inst_RX_CLK : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RX_CLK
+            hps_0_hps_io_hps_io_emac1_inst_RXD1   : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RXD1
+            hps_0_hps_io_hps_io_emac1_inst_RXD2   : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RXD2
+            hps_0_hps_io_hps_io_emac1_inst_RXD3   : in    std_logic                     := 'X';             -- hps_io_emac1_inst_RXD3
+            hps_0_hps_io_hps_io_qspi_inst_IO0     : inout std_logic                     := 'X';             -- hps_io_qspi_inst_IO0
+            hps_0_hps_io_hps_io_qspi_inst_IO1     : inout std_logic                     := 'X';             -- hps_io_qspi_inst_IO1
+            hps_0_hps_io_hps_io_qspi_inst_IO2     : inout std_logic                     := 'X';             -- hps_io_qspi_inst_IO2
+            hps_0_hps_io_hps_io_qspi_inst_IO3     : inout std_logic                     := 'X';             -- hps_io_qspi_inst_IO3
+            hps_0_hps_io_hps_io_qspi_inst_SS0     : out   std_logic;                                        -- hps_io_qspi_inst_SS0
+            hps_0_hps_io_hps_io_qspi_inst_CLK     : out   std_logic;                                        -- hps_io_qspi_inst_CLK
+            hps_0_hps_io_hps_io_sdio_inst_CMD     : inout std_logic                     := 'X';             -- hps_io_sdio_inst_CMD
+            hps_0_hps_io_hps_io_sdio_inst_D0      : inout std_logic                     := 'X';             -- hps_io_sdio_inst_D0
+            hps_0_hps_io_hps_io_sdio_inst_D1      : inout std_logic                     := 'X';             -- hps_io_sdio_inst_D1
+            hps_0_hps_io_hps_io_sdio_inst_CLK     : out   std_logic;                                        -- hps_io_sdio_inst_CLK
+            hps_0_hps_io_hps_io_sdio_inst_D2      : inout std_logic                     := 'X';             -- hps_io_sdio_inst_D2
+            hps_0_hps_io_hps_io_sdio_inst_D3      : inout std_logic                     := 'X';             -- hps_io_sdio_inst_D3
+            hps_0_hps_io_hps_io_usb1_inst_D0      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D0
+            hps_0_hps_io_hps_io_usb1_inst_D1      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D1
+            hps_0_hps_io_hps_io_usb1_inst_D2      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D2
+            hps_0_hps_io_hps_io_usb1_inst_D3      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D3
+            hps_0_hps_io_hps_io_usb1_inst_D4      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D4
+            hps_0_hps_io_hps_io_usb1_inst_D5      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D5
+            hps_0_hps_io_hps_io_usb1_inst_D6      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D6
+            hps_0_hps_io_hps_io_usb1_inst_D7      : inout std_logic                     := 'X';             -- hps_io_usb1_inst_D7
+            hps_0_hps_io_hps_io_usb1_inst_CLK     : in    std_logic                     := 'X';             -- hps_io_usb1_inst_CLK
+            hps_0_hps_io_hps_io_usb1_inst_STP     : out   std_logic;                                        -- hps_io_usb1_inst_STP
+            hps_0_hps_io_hps_io_usb1_inst_DIR     : in    std_logic                     := 'X';             -- hps_io_usb1_inst_DIR
+            hps_0_hps_io_hps_io_usb1_inst_NXT     : in    std_logic                     := 'X';             -- hps_io_usb1_inst_NXT
+            hps_0_hps_io_hps_io_spim0_inst_CLK    : out   std_logic;                                        -- hps_io_spim0_inst_CLK
+            hps_0_hps_io_hps_io_spim0_inst_MOSI   : out   std_logic;                                        -- hps_io_spim0_inst_MOSI
+            hps_0_hps_io_hps_io_spim0_inst_MISO   : in    std_logic                     := 'X';             -- hps_io_spim0_inst_MISO
+            hps_0_hps_io_hps_io_spim0_inst_SS0    : out   std_logic;                                        -- hps_io_spim0_inst_SS0
+            hps_0_hps_io_hps_io_spim1_inst_CLK    : out   std_logic;                                        -- hps_io_spim1_inst_CLK
+            hps_0_hps_io_hps_io_spim1_inst_MOSI   : out   std_logic;                                        -- hps_io_spim1_inst_MOSI
+            hps_0_hps_io_hps_io_spim1_inst_MISO   : in    std_logic                     := 'X';             -- hps_io_spim1_inst_MISO
+            hps_0_hps_io_hps_io_spim1_inst_SS0    : out   std_logic;                                        -- hps_io_spim1_inst_SS0
+            hps_0_hps_io_hps_io_uart0_inst_RX     : in    std_logic                     := 'X';             -- hps_io_uart0_inst_RX
+            hps_0_hps_io_hps_io_uart0_inst_TX     : out   std_logic;                                        -- hps_io_uart0_inst_TX
+            hps_0_hps_io_hps_io_i2c1_inst_SDA     : inout std_logic                     := 'X';             -- hps_io_i2c1_inst_SDA
+            hps_0_hps_io_hps_io_i2c1_inst_SCL     : inout std_logic                     := 'X';             -- hps_io_i2c1_inst_SCL
+            memory_mem_a                          : out   std_logic_vector(14 downto 0);                    -- mem_a
+            memory_mem_ba                         : out   std_logic_vector(2 downto 0);                     -- mem_ba
+            memory_mem_ck                         : out   std_logic;                                        -- mem_ck
+            memory_mem_ck_n                       : out   std_logic;                                        -- mem_ck_n
+            memory_mem_cke                        : out   std_logic;                                        -- mem_cke
+            memory_mem_cs_n                       : out   std_logic;                                        -- mem_cs_n
+            memory_mem_ras_n                      : out   std_logic;                                        -- mem_ras_n
+            memory_mem_cas_n                      : out   std_logic;                                        -- mem_cas_n
+            memory_mem_we_n                       : out   std_logic;                                        -- mem_we_n
+            memory_mem_reset_n                    : out   std_logic;                                        -- mem_reset_n
+            memory_mem_dq                         : inout std_logic_vector(31 downto 0) := (others => 'X'); -- mem_dq
+            memory_mem_dqs                        : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dqs
+            memory_mem_dqs_n                      : inout std_logic_vector(3 downto 0)  := (others => 'X'); -- mem_dqs_n
+            memory_mem_odt                        : out   std_logic;                                        -- mem_odt
+            memory_mem_dm                         : out   std_logic_vector(3 downto 0);                     -- mem_dm
+            memory_oct_rzqin                      : in    std_logic                     := 'X';             -- oct_rzqin
+            reset_reset_n                         : in    std_logic                     := 'X';             -- reset_n
+            atari_dma_dma_fetch                   : out   std_logic;                                        -- dma_fetch
+            atari_dma_dma_read_enable             : out   std_logic;                                        -- dma_read_enable
+            atari_dma_dma_32bit_write_enable      : out   std_logic;                                        -- dma_32bit_write_enable
+            atari_dma_dma_8bit_write_enable       : out   std_logic;                                        -- dma_8bit_write_enable
+            atari_dma_dma_addr                    : out   std_logic_vector(23 downto 0);                    -- dma_addr
+            atari_dma_dma_write_data              : out   std_logic_vector(31 downto 0);                    -- dma_write_data
+            atari_dma_memory_ready_dma            : in    std_logic                     := 'X';             -- memory_ready_dma
+            atari_dma_dma_memory_data             : in    std_logic_vector(31 downto 0) := (others => 'X');  -- dma_memory_data
+            arm_regs_pokey_enable                 : in    std_logic                     := 'X';             -- pokey_enable
+            arm_regs_in1                          : in    std_logic_vector(31 downto 0) := (others => 'X'); -- in1
+            arm_regs_in2                          : in    std_logic_vector(31 downto 0) := (others => 'X'); -- in2
+            arm_regs_in3                          : in    std_logic_vector(31 downto 0) := (others => 'X'); -- in3
+            arm_regs_in4                          : in    std_logic_vector(31 downto 0) := (others => 'X'); -- in4
+            arm_regs_out1                         : out   std_logic_vector(31 downto 0);                    -- out1
+            arm_regs_out2                         : out   std_logic_vector(31 downto 0);                    -- out2
+            arm_regs_out3                         : out   std_logic_vector(31 downto 0);                    -- out3
+            arm_regs_out4                         : out   std_logic_vector(31 downto 0);                    -- out4
+            arm_regs_out5                         : out   std_logic_vector(31 downto 0);                    -- out5
+            arm_regs_out6                         : out   std_logic_vector(31 downto 0);                    -- out6
+            arm_regs_sio_data_in                  : out   std_logic;                                        -- sio_data_in
+            arm_regs_sio_command                  : in    std_logic                     := 'X';             -- sio_command
+            arm_regs_sio_data_out                 : in    std_logic    				
+        );
+    end component atari_hps;
+	
+	component pll_pal is
+	port (
+		refclk   : in  std_logic;
+		rst      : in  std_logic;
+		outclk_0 : out std_logic;
+		outclk_1 : out std_logic;
+		locked   : out std_logic
+	);
+	end component;
+
+	
 -- PLL
 signal CLK : std_logic;
+signal CLK_HALF : std_logic;
 signal PLL_LOCKED : std_logic;
 
 -- VGA
@@ -104,6 +261,73 @@
 signal VGA_HS_RAW : std_logic;
 signal VGA_VS_RAW : std_logic;
 signal VGA_BLANK : std_logic;
+
+-- AUDIO
+signal AUDIO_LEFT : std_logic_vector(15 downto 0);
+signal AUDIO_RIGHT : std_logic_vector(15 downto 0);
+
+-- DMA
+	signal atari_dma_fetch              : std_logic;
+	signal atari_dma_read_enable        : std_logic;
+	signal atari_dma_32bit_write_enable : std_logic;
+	signal atari_dma_8bit_write_enable  : std_logic;
+	signal atari_dma_addr               : std_logic_vector(23 downto 0);
+	signal atari_dma_write_data         : std_logic_vector(31 downto 0);
+	signal atari_memory_ready_dma       : std_logic;
+	signal atari_dma_memory_data        : std_logic_vector(31 downto 0);
+
+-- ARM REGS
+	signal sio_data_in : std_logic;
+	signal sio_data_out : std_logic;
+	signal sio_command : std_logic;
+	signal out1 : std_logic_vector(31 downto 0);
+	signal out2 : std_logic_vector(31 downto 0);
+	signal out3 : std_logic_vector(31 downto 0);
+	signal out4 : std_logic_vector(31 downto 0);
+	signal out5 : std_logic_vector(31 downto 0);
+	signal out6 : std_logic_vector(31 downto 0);
+
+-- keyboard/paddles/joysticks
+	-- pokey keyboard
+	SIGNAL KEYBOARD_SCAN : std_logic_vector(5 downto 0);
+	SIGNAL KEYBOARD_RESPONSE : std_logic_vector(1 downto 0);
+	
+	-- gtia consol keys
+	SIGNAL CONSOL_START : std_logic;
+	SIGNAL CONSOL_SELECT : std_logic;
+	SIGNAL CONSOL_OPTION : std_logic;
+	SIGNAL FKEYS : std_logic_vector(11 downto 0);
+
+	signal PS2_KEYS : STD_LOGIC_VECTOR(511 downto 0);
+	signal PS2_KEYS_NEXT : STD_LOGIC_VECTOR(511 downto 0);
+
+	-- paddles
+	signal paddle_mode_next : std_logic;
+	signal paddle_mode_reg : std_logic;
+	signal		JOY1X : std_logic_vector(7 downto 0);
+	signal		JOY1Y : std_logic_vector(7 downto 0);
+	signal		JOY2X : std_logic_vector(7 downto 0);
+	signal		JOY2Y : std_logic_vector(7 downto 0);
+	
+	signal JOY1 : std_logic_vector(5 downto 0);
+	signal JOY2 : std_logic_vector(5 downto 0);
+	signal JOY1_n : std_logic_vector(4 downto 0);
+	signal JOY2_n : std_logic_vector(4 downto 0);	
+	
+	signal pokey_enable : std_logic;
+
+	-- system control from zpu
+	signal ram_select : std_logic_vector(2 downto 0);
+	signal rom_select : std_logic_vector(5 downto 0);
+	signal reset_atari : std_logic;
+	signal pause_atari : std_logic;
+	SIGNAL speed_6502 : std_logic_vector(5 downto 0);
+	signal emulated_cartridge_select: std_logic_vector(5 downto 0);
+
+	-- turbo freezer!
+	signal freezer_enable : std_logic;
+	signal freezer_activate: std_logic;
+	
 BEGIN
 	-- safe defaults
 	LED <= "1010";
@@ -115,17 +339,6 @@
 	TEMP_DIN <= 'Z';
 	TEMP_SCLK <= 'Z';
 
-	AUD_ADCDAT <= 'Z';
-	AUD_ADCLRCK <= 'Z';
-	AUD_BCLK <= 'Z';
-	AUD_DACDAT <= '0';
-	AUD_DACLRCK <= 'Z';
-	AUD_MUTE <= '0';
-	AUD_XCK <= '0';
-
-	AUD_I2C_SCLK <= '0';
-	AUD_I2C_SDAT <= 'Z';
-
 	-- Hmmm, ddr3 controller? I thought it had a hard controller...
 	DDR3_A <= (others=>'0');
 	DDR3_BA <= (others=>'0');
@@ -168,10 +381,11 @@
 	GPIO1 <= (others=>'Z');
 
 	-- pll
-pll : entity work.pll_pal
+pll : pll_pal
 	PORT MAP(refclk => OSC_50_B3B,
 	rst => not(reset_n),
 	outclk_0 => CLK,
+	outclk_1 => CLK_HALF,
 	locked => PLL_LOCKED);
 
 	-- vga
@@ -191,12 +405,12 @@
 		palette => 1,
 	
 		internal_rom => 1,
-		internal_ram => 65536
+		internal_ram => 256*4*320
 	)
 	PORT MAP
 	(
 		CLK => CLK,
-		RESET_N => PLL_LOCKED,
+		RESET_N => PLL_LOCKED and not(reset_atari),
 
 		-- VIDEO OUT - PAL/NTSC, original Atari timings approx (may be higher res)
 		VIDEO_VS => VGA_VS_RAW,
@@ -212,27 +426,32 @@
 
 		-- AUDIO OUT - Pokey/GTIA 1-bit and Covox all mixed
 		-- TODO - choose stereo/mono pokey
-		AUDIO_L => open,
-		AUDIO_R => open,
+		AUDIO_L => AUDIO_LEFT,
+		AUDIO_R => AUDIO_RIGHT,
 
 		-- JOYSTICK
-		JOY1_n => (others=>'0'),
-		JOY2_n => (others=>'0'),
+		JOY1_n => JOY1_n,
+		JOY2_n => JOY2_n,
+		
+		PADDLE0 => signed(joy1x),
+		PADDLE1 => signed(joy1y),
+		PADDLE2 => signed(joy2x),
+		PADDLE3 => signed(joy2y),
 
 		-- Pokey keyboard matrix
 		-- Standard component available to connect this to PS2
-		KEYBOARD_RESPONSE => "11",
-		KEYBOARD_SCAN => open,
+		KEYBOARD_RESPONSE => KEYBOARD_RESPONSE,
+		KEYBOARD_SCAN => KEYBOARD_SCAN,
 
 		-- SIO
-		SIO_COMMAND => open,
-		SIO_RXD => '1',
-		SIO_TXD => open,
+		SIO_COMMAND => sio_command,
+		SIO_RXD => sio_data_in,
+		SIO_TXD => sio_data_out,
 
 		-- GTIA consol
-		CONSOL_OPTION => '0',
-		CONSOL_SELECT => '0',
-		CONSOL_START => '0',
+		CONSOL_OPTION => CONSOL_OPTION,
+		CONSOL_SELECT => CONSOL_SELECT,
+		CONSOL_START => CONSOL_START,
 
 		SDRAM_REQUEST => open,
 		SDRAM_REQUEST_COMPLETE => '1',
